package report

import (
	"errors"
	"fmt"
	companyCache "hongze/hongze_yb/cache/company"
	"hongze/hongze_yb/global"
	"hongze/hongze_yb/models/tables/rddp/report_view_record"
	"hongze/hongze_yb/services/user"
	"time"
)

func AddViewRecord(params ...interface{}) {
	var err error
	userInter  := params[0]
	userInfo, ok := (userInter).(user.UserInfo)
	if !ok {
		err = errors.New("格式换转失败")
		return
	}
	defer func() {
		if err != nil {
			global.LOG.Critical(fmt.Sprintf("Task BatchInsertReportView: userId=%d, err:%s", userInfo.UserID, err.Error()))
		}
	}()

	reportId := params[1].(int)
	classifyName := params[2]
	reportChapterId := params[3].(int)
	companyInfo, err := companyCache.GetByCompanyId(userInfo.CompanyID)
	if err != nil {
		return
	}
	record := new(report_view_record.ReportViewRecord)
	record.UserId = int(userInfo.UserID)
	record.ReportId = reportId
	record.Mobile = userInfo.Mobile
	record.Email = userInfo.Email
	record.RealName = userInfo.RealName
	record.CompanyName = companyInfo.CompanyName
	record.CreateTime = time.Now()
	if classifyName == "晨报" || classifyName == "周报" {
		record.ReportChapterId = reportChapterId
	}
	err = report_view_record.Create(record)
	if err != nil {
		return
	}
	//修改联系人最后一次阅读报告时间
	err = userInfo.WxUser.SetWxUserReportLastViewTime()
	return
}
